import ExpressionEval
import Visitor

class ASTLinearizer(Visitor.Visitor):
    """
    Walk the AST in depth-first order and return linearized list
    of SeletorRule instances. Other node types are ignored.
    This visitor should be called for a root-level rule node.
    """

    def visit_BlockRule(self, ast, arg):
        li = []
        for rule in ast.rules:
            li.extend(rule.visit(self))
        return li

    def visit_IfBlockRule(self, ast, arg):
        if not ast.if_expr.visit(ExpressionEval.ExpressionEval()):
            return []
        ast.if_expr = None
        return self.visit_BlockRule(ast, arg)

    def visit_GloblistRule(self, ast, arg):
        if ast.if_expr:
            if not ast.if_expr.visit(ExpressionEval.ExpressionEval()):
                return []
            ast.if_expr = None
        return [ast]

    def visit_ForEachRule(self, ast, arg):
        return [ast]

    # Other visit_* methods not implemented, they don't get visited.